function ObserverHUDOutputStats(%missionend)
{
	ObserverHUD.OutputStats(%missionend);
}

function ObserverHUD::printHTMLLine(%this, %bypasshtmltext, %text0, %data0, %text1, %data1, %text2, %data2, %text3, %data3, %text4, %data4, %text5, %data5, %text6, %data6, %text7, %data7, %text8, %data8, %text9, %data9)
{
	// we shouldn't really have to do this... but it seems to make it work.
	%text[0] = %text0;
	%text[1] = %text1;
	%text[2] = %text2;
	%text[3] = %text3;
	%text[4] = %text4;
	%text[5] = %text5;
	%text[6] = %text6;
	%text[7] = %text7;
	%text[8] = %text8;
	%text[9] = %text9;

	%data[0] = %data0;
	%data[1] = %data1;
	%data[2] = %data2;
	%data[3] = %data3;
	%data[4] = %data4;
	%data[5] = %data5;
	%data[6] = %data6;
	%data[7] = %data7;
	%data[8] = %data8;
	%data[9] = %data9;

	for(%f=0; %f<10; %f++)
	{
		%pass = 0;
		%lastcomma = 0;
		%string = %data[%f];
		%length = strlen(%string);
		for(%i = 0; %i < %length; %i++)
		{
			%char = getSubStr(%string, %i, 1);
			if(%char $= ",")
			{
				%pass++;
				if(%pass == 1)
					%classtext[%f] = getSubStr(%string, %lastcomma, %i-%lastcomma);
				else if(%pass == 2)
					%colspan[%f] = getSubStr(%string, %lastcomma+1, %i-%lastcomma-1);
				else if(%pass == 3)
					%width[%f] = getSubStr(%string, %lastcomma+1, %i-%lastcomma-1);
				%lastcomma = %i;
			}
		}
		%align[%f] = getSubStr(%string, %lastcomma+1, %length-%lastcomma-1);
		if(%data[%f+1] $= "")
			%f = 11;
	}


	%this.filehtmleditor.writeline("  <tr>");

	//check for # of columns passed
	if (%text9 !$= "")
		%numcols = 10;
	else if (%text8 !$= "")
		%numcols = 9;
	else if (%text7 !$= "")
		%numcols = 8;
	else if (%text6 !$= "")
		%numcols = 7;
	else if (%text5 !$= "")
		%numcols = 6;
	else if (%text4 !$= "")
		%numcols = 5;
	else if (%text3 !$= "")
		%numcols = 4;
	else if (%text2 !$= "")
		%numcols = 3;
	else if (%text1 !$= "")
		%numcols = 2;
	else
		%numcols = 1;


	for (%i = 0; %i < %numcols; %i++)
	{
		if(!%bypasshtmltext)
		{
			// check to see if text needs to be html-er-cised
			if (strreplace(%text[%i], " ", "") $= "")
				%text[%i] = "&nbsp;";
			else
			{
				%text[%i] = strreplace(%text[%i], "&", "&amp;");
				%text[%i] = strreplace(%text[%i], "<", "&lt;");
				%text[%i] = strreplace(%text[%i], ">", "&gt;");
			}
		}
		// check to see if align needs to be specified
		if (%align[%i] !$= "")
			%aligntext = " align=" @ %align[%i];
		else
			%aligntext = "";
		// check to see if width needs to be specified
		if (%width[%i] !$= "")
			%widthtext = " width=" @ %width[%i];
		else
			%widthtext = "";
		// check to see if colspan needs to be specified
		if (%colspan[%i] > 1)
			%colspantext = " colspan=" @ %colspan[%i];
		else
			%colspantext = "";
		%classtext = %classtext[%i];
		// output content
		%this.filehtmleditor.writeline("    <td class=" @ %classtext @ %widthtext @ %aligntext @ %colspantext @ ">");
		%this.filehtmleditor.writeline("      <p class=" @ %classtext @ ">" @ %text[%i] @ "</p>");
		%this.filehtmleditor.writeline("    </td>");
	}
	%this.filehtmleditor.writeline("  </tr>");
}


function ObserverHUD::OutputStats(%this, %missionend)
{
	//determine file name
	if(%missionend || $ObserverHUDSettings::SpecificLocation $= "")
	{
		%j = 2;
		for(%i = 1; %i < %j; %i++)
		{
			%filename = "ObserverHUD/" @ ObserverHUDMissionData.MissionName @ %i @ ".html";
			if(!isfile(%filename))
			{
				%outputfileid = %i;
				%outputFilename = %filename;
				%i++;
			}
			else
			{
				%j++;
			}
		}
	}
	else
		%filename = "ObserverHUD/" @ $ObserverHUDSettings::SpecificLocation @ ".html";

	//create file editor object
	if(!isobject(%this.filehtmleditor))
	{
		 %this.filehtmleditor = new FileObject();
	}

	//Create Player Team Listing
	$ObserverHUDHTML::TeamPlayerCount[1]=0;
	$ObserverHUDHTML::TeamPlayerCount[2]=0;
	$ObserverHUDHTML::TeamPlayerCount[0]=0;

	//Recalc Mission Time
	ObserverHUD.UpdateGameTimer();

	%i = 0;
	%p = PlayerList.findByIndex(%i);
	while (%p !$= $PLAYER_ERROR)
	{
		ObserverHUD.UpdateClientTeamTimes(%p.name);
		%team1time = ObserverHUDMissionData.ClientTeamTime[%name, 1];
		%team2time = ObserverHUDMissionData.ClientTeamTime[%name, 2];

		if(%p.teamID > 0)
		{
			%team = %p.teamID;
			$ObserverHUDHTML::TeamPlayerCount[%team]++;
			$ObserverHUDHTML::ClientIDtoTeam[%p.clientID] = %team;
		}
		else if(%team1time <= 45 && %team2time <= 45)
		{
			$ObserverHUDHTML::TeamPlayerCount[0]++;
			$ObserverHUDHTML::ClientIDtoTeam[%p.clientID] = 0;
		}
		else if(%team1time >= %team2time)
		{
			$ObserverHUDHTML::TeamPlayerCount[1]++;
			$ObserverHUDHTML::ClientIDtoTeam[%p.clientID] = 1;
		}
		else
		{
			$ObserverHUDHTML::TeamPlayerCount[2]++;
			$ObserverHUDHTML::ClientIDtoTeam[%p.clientID] = 2;
		}

		%i++;
		%p = PlayerList.findByIndex(%i);
	}

	%this.filehtmleditor.openForWrite(%filename);
	//Write Header
	%this.OutputHeaderInfo(true);
	//Write Server Info
	if($ObserverHUDSettings::FormatServerDetails)
		%this.OutputServerInfo();
	//Write Team Info
	if($ObserverHUDSettings::FormatTeamDetails)
		%this.OutputTeamInfo();
	//Write Player Details
	if($ObserverHUDSettings::FormatPlayerDetails)
		%this.OutputPlayerInfo();
	//Write Footer
	%this.OutputFooterInfo(true);
	%this.filehtmleditor.close();

	echo("ObserverHUD:  Html Output Complete");
}

function ObserverHUD::OutputHeaderInfo(%this)
{
	$ObserverHUDSettings::MainWidth = $ObserverHUDSettings::MainWidth $= "" ? 600 : $ObserverHUDSettings::MainWidth;

	%this.filehtmleditor.writeline("<html>");
	%this.filehtmleditor.writeline("<head>");
	%this.filehtmleditor.writeline("<title>ObserverHUD Stats v" @ ObserverHUD.version @ " - Tribes 2</title>");
	if($ObserverHUDSettings::UseCssFile)
	{
		%this.OutputCssFile();
		%this.filehtmleditor.writeline("	<link rel=\"stylesheet\" href=\"obshud.css\" type=\"text/css\">");
	}
	else
	{
		%this.filehtmleditor.writeline("<style>");
		%this.filehtmleditor.writeline("<!--");
		%this.IncludeCssFile();
		%this.filehtmleditor.writeline("-->");
		%this.filehtmleditor.writeline("</style>");
	}
	%this.filehtmleditor.writeline("</head>");
	%this.filehtmleditor.writeline("<body leftmargin=\"0\" topmargin=\"00\" marginwidth=\"000\" marginheight=\"0000\">");
	%this.filehtmleditor.writeline("<table width=\""@$ObserverHUDSettings::MainWidth@"\" border=\"0\" cellspacing=\"0\" cellpadding=\"10\" align=\"center\">");
	%this.filehtmleditor.writeline("  <tr>");
	%this.filehtmleditor.writeline("  <td align=\"center\">");
}

function ObserverHUD::OutputFooterInfo(%this, %standard)
{
	//pre footer
	%this.filehtmleditor.writeline("    <p><a href=\"#top\">Click here to return to the top</a></p>");
	%this.filehtmleditor.writeline("    <p>&nbsp;</p>");
	%this.filehtmleditor.writeline("    <p>These Stats where produced using ObserverHUD version 0.60 by Wizard_TPG<br>");
	%this.filehtmleditor.writeline("    ObserverHUD version " @ ObserverHUD.version @ " fixed by: ^BuGs^, kesh!, and Katien.<br>");
	%this.filehtmleditor.writeline("    Please visit the website at <a href=\"http://www.bugssite.org/tribes/2/\" target=\"_blank\">the rabbit hole: tribes 2 scripts</a></p>");
	%this.filehtmleditor.writeline("    <p>HTML designed by <a href=\"http://www.cowboyscripts.org\" target=\"_blank\">Cowboy</a></p>");
	if(!%standard)
	{
		//none as yet
	}
	//block footer
	%this.filehtmleditor.writeline("    </td>");
	%this.filehtmleditor.writeline("  </tr>");
	%this.filehtmleditor.writeline("</table>");
	%this.filehtmleditor.writeline("</body>");
	%this.filehtmleditor.writeline("</html>");
}

function ObserverHUD::OutputServerInfo(%this)
{
	%this.filehtmleditor.writeline("<!-- Begin Game Info Block -->");
	%this.filehtmleditor.writeline("    <h3>Game Info</h3>");
	%this.filehtmleditor.writeline("    <table width=\"100%\" border=\"0\" cellspacing=\"6\" cellpadding=\"0\">");
	%this.filehtmleditor.writeline("      <tr valign=\"top\">");
	%this.filehtmleditor.writeline("      <td class=\"main\" colspan=\"2\">");
	%this.filehtmleditor.writeline("        <table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">");
	%this.filehtmleditor.writeline("          <tr>");
	%this.filehtmleditor.writeline("            <td>&nbsp;</td>");
	%this.filehtmleditor.writeline("          </tr>");
	%this.filehtmleditor.writeline("          <tr>");
	%this.filehtmleditor.writeline("            <td><h3 align=\"center\" class=\"main\">"@ObserverHUDServerData.ServerName@"</h3></td>");
	%this.filehtmleditor.writeline("          </tr>");
	%this.filehtmleditor.writeline("        </table>");
	%this.filehtmleditor.writeline("        <table width=\"100%\" border=\"0\" cellspacing=\"2\" cellpadding=\"2\" align=\"center\">");
	%this.filehtmleditor.writeline("<!-- Begin Game Info Content -->");

	%colourcode = 0;
	ObserverHUDServerData.ServerName = ObserverHUDServerData.ServerName $= "" ? "Unknown" : ObserverHUDServerData.ServerName;
	ObserverHUDServerData.ServerAddress = ObserverHUDServerData.ServerAddress $= "" ? "N/A" : ObserverHUDServerData.ServerAddress;

	%this.printHTMLLine(false, "Server", "t,2,,center", "Map", "t,2,,center");
	%this.printHTMLLine(false, "Name", "c" @ %colourcode @",1,15%,", ObserverHUDServerData.ServerName, "c" @ %colourcode @",1,35%, center", "Name", "c" @ %colourcode @",1,15%,", ObserverHUDMissionData.MissionName, "c" @ %colourcode @",1,35%,center");
	%colourcode = %colourcode == 1 ? 0 : 1;
	%this.printHTMLLine(false, "Address", "c" @ %colourcode @",1,15%,", ObserverHUDServerData.ServerAddress, "c" @ %colourcode @",1,35%,center", "Type", "c" @ %colourcode @",1,15%,", ObserverHUDMissionData.MissionType, "c" @ %colourcode @",1,35%,center");
	%colourcode = %colourcode == 1 ? 0 : 1;

	ObserverHUDMissionData.TimeLimit = ObserverHUDMissionData.TimeLimit $= "" ? 0 : ObserverHUDMissionData.TimeLimit;
	ObserverHUDMissionData.MissionTime = ObserverHUDMissionData.MissionTime > 0 ? ObserverHUDMissionData.MissionTime : ObserverHUDMissionData.TimeLimit;
	%timedata = ObserverHUDMissionData.TimeLimit * 60;
	%timedata2 = ObserverHUDMissionData.MissionTime + 1;
	if(%timedata == %timedata2)
	{
		ObserverHUDMissionData.IncreaseTime = true;
		ObserverHUDMissionData.MissionTime = ObserverHUDMissionData.MissionTime + 1;
	}

	%value = ObserverHUDMissionData.MissionTime/60;
	%min = mfloor(%value);
	%ssec = ObserverHUDMissionData.MissionTime - (%min * 60);
	%sec = mfloor(%ssec);
	%sec = %sec $= "0" ? "00" : %sec;
	%sec = %sec < 10 ? "0"@%sec : %sec;
	%sec = %sec $= "000" ? "00" : %sec;
	%time = %min @ ":" @ %sec;

	ObserverHUDServerData.ServerMod = ObserverHUDServerData.ServerMod $= "" ? "N/A" : ObserverHUDServerData.ServerMod;
	ObserverHUDServerData.ServerType = ObserverHUDServerData.ServerType $= "" ? "N/A" : ObserverHUDServerData.ServerType;
	%this.printHTMLLine(false, "Mod", "c" @ %colourcode @",1,15%,", ObserverHUDServerData.ServerMod, "c" @ %colourcode @",1,35%,center", "Mission Time", "c" @ %colourcode @",1,15%,", %time, "c" @ %colourcode @",1,35%,center");
	%colourcode = %colourcode == 1 ? 0 : 1;
	%this.printHTMLLine(false, "Type", "c" @ %colourcode @",1,15%,", ObserverHUDServerData.ServerType, "c" @ %colourcode @",1,35%,center", "Time Limit", "c" @ %colourcode @",1,15%,", ObserverHUDMissionData.TimeLimit@":00", "c" @ %colourcode @",1,35%,center");

	%this.filehtmleditor.writeline("<!-- End Game Info Content -->");
	%this.filehtmleditor.writeline("        </table>");
	%this.filehtmleditor.writeline("      </td>");
	%this.filehtmleditor.writeline("    </tr>");
	%this.filehtmleditor.writeline("    </table>");
	%this.filehtmleditor.writeline("    <p>&nbsp;</p>");
	%this.filehtmleditor.writeline("<!-- End Game Info Block -->");
}

function ObserverHUD::OutputTeamInfo(%this)
{
	%this.filehtmleditor.writeline("<!-- Begin Team Stats Block -->");
	%this.filehtmleditor.writeline("    <h3>Team Stats</h3>");
	%this.filehtmleditor.writeline("    <table width=\"100%\" border=\"0\" cellspacing=\"6\" cellpadding=\"0\">");
	%this.filehtmleditor.writeline("      <tr valign=\"top\">");
	%this.filehtmleditor.writeline("        <td class=\"main\" width=\"50%\">");
	%this.filehtmleditor.writeline("<!-- Begin Team1 Info Block -->");

	%this.OutputTeamInfoTeam(1);

	%this.filehtmleditor.writeline("<!-- End Team1 Info Block -->");
	%this.filehtmleditor.writeline("        </td>");
	%this.filehtmleditor.writeline("        <td class=\"main\" width=\"50%\">");
	%this.filehtmleditor.writeline("<!-- Begin Team2 Info Block -->");

	%this.OutputTeamInfoTeam(2);

	%this.filehtmleditor.writeline("<!-- End Team2 Info Block -->");
	%this.filehtmleditor.writeline("        </td>");
	%this.filehtmleditor.writeline("      </tr>");
	%this.filehtmleditor.writeline("      <tr valign=\"top\">");
	%this.filehtmleditor.writeline("        <td class=\"main\" colspan=\"2\">");
	%this.filehtmleditor.writeline("          <table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">");
	%this.filehtmleditor.writeline("            <tr>");
	%this.filehtmleditor.writeline("              <td>&nbsp;</td>");
	%this.filehtmleditor.writeline("            </tr>");
	%this.filehtmleditor.writeline("            <tr>");
	%this.filehtmleditor.writeline("              <td><h3 align=\"center\" class=\"main\">Observers</h3></td>");
	%this.filehtmleditor.writeline("            </tr>");
	%this.filehtmleditor.writeline("          </table>");
	%this.filehtmleditor.writeline("          <table width=\"100%\" border=\"0\" cellspacing=\"2\" cellpadding=\"2\" align=\"center\">");
	%this.filehtmleditor.writeline("<!-- Begin Observers Content -->");

	%colourcode = 0;
	%this.printHTMLLine(false, "Name", "t,2,,");

	%i = 0;
	%p = PlayerList.findByIndex(%i);
	while (%p !$= $PLAYER_ERROR)
	{
		if($ObserverHUDHTML::ClientIDtoTeam[%p.clientID] == 0)
		{
			%name = StripNameColors(%p.name);
			if(%name !$= "")
			{
				%this.printHTMLLine(false, %name, "c" @ %colourcode @",2,,");
				%colourcode = %colourcode == 1 ? 0 : 1;
			}
		}
		%i++;
		%p = PlayerList.findByIndex(%i);
	}

	%this.filehtmleditor.writeline("<!-- End Observers Content -->");
	%this.filehtmleditor.writeline("          </table>");
	%this.filehtmleditor.writeline("        </td>");
	%this.filehtmleditor.writeline("      </tr>");
	%this.filehtmleditor.writeline("    </table>");
	%this.filehtmleditor.writeline("    <p>&nbsp;</p>");
	%this.filehtmleditor.writeline("<!-- End Team Stats Block -->");
}


function ObserverHUD::OutputTeamInfoTeam(%this, %team)
{
	%this.filehtmleditor.writeline("          <table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\">");
	%this.filehtmleditor.writeline("            <tr>");
	%this.filehtmleditor.writeline("              <td>&nbsp;</td>");
	%this.filehtmleditor.writeline("            </tr>");
	%this.filehtmleditor.writeline("            <tr>");
	if(%team == 1)
		$ObserverHUDSettings::TeamName[%team] = $ObserverHUDSettings::ClanName1;
	else if (%team == 2)
		$ObserverHUDSettings::TeamName[%team] = $ObserverHUDSettings::ClanName2;
	if(ObserverHUDMissionData.TeamIDtoName[%team] $= "")
	{
		if(%team == 1)
			ObserverHUDMissionData.TeamIDtoName[%team] = "Storm";
		else
			ObserverHUDMissionData.TeamIDtoName[%team] = "Inferno";
	}
	if($ObserverHUDSettings::TeamName[%team] !$= "")
		%this.filehtmleditor.writeline("              <td><h3 align=\"center\" class=\"main\">"@$ObserverHUDSettings::TeamName[%team]@"<br>"@ObserverHUDMissionData.TeamIDtoName[%team]@"</h3>");
	else
		%this.filehtmleditor.writeline("              <td><h3 align=\"center\" class=\"main\">"@ObserverHUDMissionData.TeamIDtoName[%team]@"</h3>");
	%this.filehtmleditor.writeline("            </td>");
	%this.filehtmleditor.writeline("            </tr>");
	%this.filehtmleditor.writeline("          </table>");
	%this.filehtmleditor.writeline("          <table width=\"100%\" border=\"0\" cellspacing=\"2\" cellpadding=\"2\" align=\"center\">");
	%this.filehtmleditor.writeline("<!-- Begin Team Info Content -->");

	%colourcode = 0;
	%this.printHTMLLine(false, "Summary", "t,2,,center");
	ObserverHUDMissionData.TeamScore[%team] = ObserverHUDMissionData.TeamScore[%team] $= "" ? 0 : ObserverHUDMissionData.TeamScore[%team];
	%this.printHTMLLine(false, "Score", "c" @ %colourcode @",1,70%,", ObserverHUDMissionData.TeamScore[%team], "c" @ %colourcode @",1,30%,center");
	%colourcode = %colourcode == 1 ? 0 : 1;
	%pingtotal = 0;
	%pltotal = 0;
	%counttotal = 0;
	%timetotal = 0;

	%i = 0;
	%p = PlayerList.findByIndex(%i);
	while (%p !$= $PLAYER_ERROR)
	{
		if($ObserverHUDHTML::ClientIDtoTeam[%p.clientID] == %team)
		{
			%name = %p.name;
			%pingtotal += ObserverHUDMissionData.ClientPingTotal[%name];
			%pltotal += ObserverHUDMissionData.ClientPLTotal[%name];
			%counttotal += ObserverHUDMissionData.ClientPingTest[%name];
			if(ObserverHUDMissionData.IncreaseTime)
				%timetotal = %timetotal + ObserverHUDMissionData.ClientTeamTime[%name, %team] + 1;
			else
				%timetotal += ObserverHUDMissionData.ClientTeamTime[%name, %team];
		}
		%i++;
		%p = PlayerList.findByIndex(%i);
	}
	%pping = %pingtotal / %counttotal;
	%ppl = %pltotal / %counttotal;
	%ping = mfloor(%pping);
	%pl = mfloor(%ppl);
	%pingpl = %ping == 0 ? "N/A" : %ping @ " / " @ %pl;
	if(%ping > 2000 || %ping < 0)
		%pingpl = "N/A";
	%this.printHTMLLine(false, "Average Ping / PL", "c" @ %colourcode @",1,70%,", %pingpl, "c" @ %colourcode @",1,30%,center");
	%colourcode = %colourcode == 1 ? 0 : 1;
	ObserverHUDMissionData.MaxTeamPlayers[%team] = ObserverHUDMissionData.MaxTeamPlayers[%team] $= "" ? 0 : ObserverHUDMissionData.MaxTeamPlayers[%team];
	ObserverHUDMissionData.MaxTeamPlayers[%team] = ObserverHUDMissionData.MaxTeamPlayers[%team] $= " " ? 0 : ObserverHUDMissionData.MaxTeamPlayers[%team];
	%this.printHTMLLine(false, "Max Players", "c" @ %colourcode @",1,70%,", ObserverHUDMissionData.MaxTeamPlayers[%team], "c" @ %colourcode @",1,30%,center");
	%colourcode = %colourcode == 1 ? 0 : 1;
	if($ObserverHUDSettings::MaxPlayerLimit)
		%maxplayers = $ObserverHUDSettings::MaxPlayerLimit;
	else
		%maxplayers = $ObserverHUDHTML::TeamPlayerCount[1] > $ObserverHUDHTML::TeamPlayerCount[2] ? $ObserverHUDHTML::TeamPlayerCount[1] : $ObserverHUDHTML::TeamPlayerCount[2];
	%timeperplayer = %timetotal/%maxplayers;
	%value = (%timeperplayer/ObserverHUDMissionData.MissionTime)*100;
	%time = mfloor(%value);
	%this.printHTMLLine(false, "Time", "c" @ %colourcode @",1,70%,", %time@"%", "c" @ %colourcode @",1,30%,center");
	if($ObserverHUDSettings::MaxPlayerLimit)
		%this.printHTMLLine(false, "(Time based on "@$ObserverHUDSettings::MaxPlayerLimit@"-man team size)", "c" @ %colourcode @",2,,center");

	ObserverHUDMissionData.TeamFlagGrab[%team] = ObserverHUDMissionData.TeamFlagGrab[%team] $= "" ? 0 : ObserverHUDMissionData.TeamFlagGrab[%team];
	ObserverHUDMissionData.TeamFlagCap[%team] = ObserverHUDMissionData.TeamFlagCap[%team] $= "" ? 0 : ObserverHUDMissionData.TeamFlagCap[%team];
	ObserverHUDMissionData.TeamFlagDrop[%team] = ObserverHUDMissionData.TeamFlagDrop[%team] $= "" ? 0 : ObserverHUDMissionData.TeamFlagDrop[%team];
	ObserverHUDMissionData.TeamFlagReturn[%team] = ObserverHUDMissionData.TeamFlagReturn[%team] $= "" ? 0 : ObserverHUDMissionData.TeamFlagReturn[%team];
	ObserverHUDMissionData.TeamGrab[%team] = ObserverHUDMissionData.TeamGrab[%team] $= "" ? 0 : ObserverHUDMissionData.TeamGrab[%team];
	ObserverHUDMissionData.TeamKill[%team] = ObserverHUDMissionData.TeamKill[%team] $= "" ? 0 : ObserverHUDMissionData.TeamKill[%team];
	ObserverHUDMissionData.TeamTurretKill[%team] = ObserverHUDMissionData.TeamTurretKill[%team] $= "" ? 0 : ObserverHUDMissionData.TeamTurretKill[%team];
	ObserverHUDMissionData.TeamTeamKill[%team] = ObserverHUDMissionData.TeamTeamKill[%team] $= "" ? 0 : ObserverHUDMissionData.TeamTeamKill[%team];
	ObserverHUDMissionData.TeamSuicide[%team] = ObserverHUDMissionData.TeamSuicide[%team] $= "" ? 0 : ObserverHUDMissionData.TeamSuicide[%team];
	ObserverHUDMissionData.TeamDeath[%team] = ObserverHUDMissionData.TeamDeath[%team] $= "" ? 0 : ObserverHUDMissionData.TeamDeath[%team];
	ObserverHUDMissionData.TeamTurretDeath[%team] = ObserverHUDMissionData.TeamTurretDeath[%team] $= "" ? 0 : ObserverHUDMissionData.TeamTurretDeath[%team];
	ObserverHUDMissionData.TeamOtherDeath[%team] = ObserverHUDMissionData.TeamOtherDeath[%team] $= "" ? 0 : ObserverHUDMissionData.TeamOtherDeath[%team];

	%colourcode = 0;
	%this.printHTMLLine(false, "Gameplay Stats", "t,2,,center");
	%this.printHTMLLine(false, "Flag Grabs/Pickups", "c" @ %colourcode @",1,70%, ", ObserverHUDMissionData.TeamFlagGrab[%team], "c" @ %colourcode @",1,30%,center");
	%colourcode = %colourcode == 1 ? 0 : 1;
	%this.printHTMLLine(false, "Flag Caps", "c" @ %colourcode @",1,70%,", ObserverHUDMissionData.TeamFlagCap[%team], "c" @ %colourcode @",1,30%,center");
	%colourcode = %colourcode == 1 ? 0 : 1;
	%this.printHTMLLine(false, "Flag Drops", "c" @ %colourcode @",1,70%,", ObserverHUDMissionData.TeamFlagDrop[%team], "c" @ %colourcode @",1,30%,center");
	%colourcode = %colourcode == 1 ? 0 : 1;
	%this.printHTMLLine(false, "Flag Returns", "c" @ %colourcode @",1,70%,", ObserverHUDMissionData.TeamFlagReturn[%team], "c" @ %colourcode @",1,30%,center");
	%colourcode = %colourcode == 1 ? 0 : 1;
	%this.printHTMLLine(false, "Objective Grabs", "c" @ %colourcode @",1,70%,", ObserverHUDMissionData.TeamGrab[%team], "c" @ %colourcode @",1,30%,center");
	%colourcode = 0;
	%this.printHTMLLine(false, "Kills / Deaths", "t,2,,center");
	%this.printHTMLLine(false, "Kills by Player", "c" @ %colourcode @",1,70%,", ObserverHUDMissionData.TeamKill[%team], "c" @ %colourcode @",1,30%,center");
	%colourcode = %colourcode == 1 ? 0 : 1;
	%this.printHTMLLine(false, "Kills by Turret", "c" @ %colourcode @",1,70%,", ObserverHUDMissionData.TeamTurretKill[%team], "c" @ %colourcode @",1,30%,center");
	%colourcode = %colourcode == 1 ? 0 : 1;
	%this.printHTMLLine(false, "Team Kills", "c" @ %colourcode @",1,70%,", ObserverHUDMissionData.TeamTeamKill[%team], "c" @ %colourcode @",1,30%,center");
	%colourcode = %colourcode == 1 ? 0 : 1;
	%this.printHTMLLine(false, "Suicides", "c" @ %colourcode @",1,70%,", ObserverHUDMissionData.TeamSuicide[%team], "c" @ %colourcode @",1,30%,center");
	%colourcode = %colourcode == 1 ? 0 : 1;
	%this.printHTMLLine(false, "Deaths by Player", "c" @ %colourcode @",1,70%,", ObserverHUDMissionData.TeamDeath[%team], "c" @ %colourcode @",1,30%,center");
	%colourcode = %colourcode == 1 ? 0 : 1;
	%this.printHTMLLine(false, "Deaths by Turret", "c" @ %colourcode @",1,70%,", ObserverHUDMissionData.TeamTurretDeath[%team], "c" @ %colourcode @",1,30%,center");
	%colourcode = %colourcode == 1 ? 0 : 1;
	%this.printHTMLLine(false, "Deaths by Other", "c" @ %colourcode @",1,70%,", ObserverHUDMissionData.TeamOtherDeath[%team], "c" @ %colourcode @",1,30%,center");
	%this.filehtmleditor.writeline("<!-- End Team Info Content -->");
	%this.filehtmleditor.writeline("          </table>");
	%this.filehtmleditor.writeline("          <h3 align=\"center\" class=\"main\"><a name=\"playerlist\"></a>Player Info</h3>");
	%this.filehtmleditor.writeline("          <table width=\"100%\" border=\"0\" cellspacing=\"2\" cellpadding=\"2\" align=\"center\">");
	%this.filehtmleditor.writeline("<!-- Begin Team PlayerInfo Block -->");
	%this.printHTMLLine(false, "Name", "t,2,60%,center", "Score", "t,2,20%,center", "Time", "t,2,20%,center");
	%colourcode = 0;
	%linecount = 0;

	%i = 0;
	%p = PlayerList.findByIndex(%i);
	while (%p !$= $PLAYER_ERROR)
	{
		if($ObserverHUDHTML::ClientIDtoTeam[%p.clientID] == %team)
		{
			%colourcode = %colourcode == 1 ? 0 : 1;
			%name = %p.name;
			%displayanme = StripNameColors(%name);
			if(ObserverHUDMissionData.IncreaseTime)
				ObserverHUDMissionData.ClientTeamTime[%name, %team] += 1;
			%value = ObserverHUDMissionData.ClientTeamTime[%name, %team]/60;
			%min = mfloor(%value);
			%value = ObserverHUDMissionData.ClientTeamTime[%name, %team] - (%min * 60);
			%sec = mfloor(%value);
			%sec = %sec $= "0" ? "00" : %sec;
			%sec = %sec < 10 ? "0"@%sec : %sec;
			%sec = %sec $= "000" ? "00" : %sec;
			%time = %min @ ":" @ %sec;
			%this.printHTMLLine(true, "<a href=#p"@%p.clientID@" class=c"@ %colourcode @">"@%displayanme@"</a>", "c" @ %colourcode @",2,60%,", %p.score, "c" @ %colourcode @",2,20%,center", %time, "c" @ %colourcode @",2,20%,center");
			%linecount++;
		}
		%i++;
		%p = PlayerList.findByIndex(%i);
	}

	%maxlinecount = $ObserverHUDHTML::TeamPlayerCount[1] > $ObserverHUDHTML::TeamPlayerCount[2] ? $ObserverHUDHTML::TeamPlayerCount[1] : $ObserverHUDHTML::TeamPlayerCount[2];
	for(%i = %linecount; %i < %maxlinecount; %i++)
	{
		%colourcode = %colourcode == 1 ? 0 : 1;
		%this.printHTMLLine(true, "&nbsp;", "c" @ %colourcode @",2,60%,", "&nbsp;", "c" @ %colourcode @",2,20%,center", "&nbsp;", "c" @ %colourcode @",2,20%,center");
	}

	%this.filehtmleditor.writeline("<!-- End Team PlayerInfo Block -->");
	%this.filehtmleditor.writeline("          </table>");
}



function ObserverHUD::OutputPlayerInfo(%this)
{
	%this.filehtmleditor.writeline("<!-- Begin Player Stats Block -->");
	%this.filehtmleditor.writeline("    <h3>Player Stats</h3>");

	%z = 0;
	%p = PlayerList.findByIndex(%z);
	while (%p !$= $PLAYER_ERROR)
	{
		%name = %p.name;
		%dispname = StripNameColors(%p.name);
		%this.filehtmleditor.writeline("    <p><a name=p"@%p.clientID@"></a></p>");
		%this.filehtmleditor.writeline("    <table width=\"100%\" border=\"0\" cellspacing=\"6\" cellpadding=\"0\">");
		%this.filehtmleditor.writeline("      <tr>");
		%this.filehtmleditor.writeline("        <td class=\"main\" valign=\"top\">");
		%this.filehtmleditor.writeline("          <table width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"2\">");
		%this.filehtmleditor.writeline("            <tr>");
		%this.filehtmleditor.writeline("              <td><p align=\"right\"><a href=\"#playerlist\" class=\"main\">back to player list</a></p></tr>");
		%this.filehtmleditor.writeline("            <tr>");
		%this.filehtmleditor.writeline("              <td><h3 align=\"center\" class=\"main\">"@%dispname@"</h3></td>");
		%this.filehtmleditor.writeline("            </tr>");
		%this.filehtmleditor.writeline("          </table>");
		%this.filehtmleditor.writeline("          <table width=\"100%\" border=\"0\" cellspacing=\"2\" cellpadding=\"2\" align=\"center\">");
		%this.filehtmleditor.writeline("<!-- Begin Player Info Content -->");
		%colourcode = 0;

		ObserverHUDMissionData.ClientFlagGrab[%name] = ObserverHUDMissionData.ClientFlagGrab[%name] $= "" ? 0 : ObserverHUDMissionData.ClientFlagGrab[%name];
		ObserverHUDMissionData.ClientFlagCap[%name] = ObserverHUDMissionData.ClientFlagCap[%name] $= "" ? 0 : ObserverHUDMissionData.ClientFlagCap[%name];
		ObserverHUDMissionData.ClientFlagDrop[%name] = ObserverHUDMissionData.ClientFlagDrop[%name] $= "" ? 0 : ObserverHUDMissionData.ClientFlagDrop[%name];
		ObserverHUDMissionData.ClientFlagReturn[%name] = ObserverHUDMissionData.ClientFlagReturn[%name] $= "" ? 0 : ObserverHUDMissionData.ClientFlagReturn[%name];
		ObserverHUDMissionData.ClientGrab[%name] = ObserverHUDMissionData.ClientGrab[%name] $= "" ? 0 : ObserverHUDMissionData.ClientGrab[%name];
		ObserverHUDMissionData.ClientTeamKill[%name] = ObserverHUDMissionData.ClientTeamKill[%name] $= "" ? 0 : ObserverHUDMissionData.ClientTeamKill[%name];

		%this.printHTMLLine(false, "Summary", "t,3,,center", "Gameplay Stats", "t,3,,center");
		%this.printHTMLLine(false, "Score", "c" @ %colourcode @",1,30%,", %p.score, "c" @ %colourcode @",2,20%,center", "Flag Grabs/Pickups", "c" @ %colourcode @",1,30%,", ObserverHUDMissionData.ClientFlagGrab[%name], "c" @ %colourcode @",2,20%,center");
		%colourcode = %colourcode == 1 ? 0 : 1;

		%team = $ObserverHUDHTML::ClientIDtoTeam[%p.clientID];
		%value = ObserverHUDMissionData.ClientTeamTime[%name, %team]/60;
		%min = mfloor(%value);
		%value = ObserverHUDMissionData.ClientTeamTime[%name, %team] - (%min * 60);
		%sec = mfloor(%value);
		%sec = %sec $= "0" ? "00" : %sec;
		%sec = %sec < 10 ? "0"@%sec : %sec;
		%sec = %sec $= "000" ? "00" : %sec;
		%time = %min @ ":" @ %sec;
		ObserverHUDMissionData.ClientKill[%name] = ObserverHUDMissionData.ClientKill[%name] $= "" ? 0 : ObserverHUDMissionData.ClientKill[%name];
		ObserverHUDMissionData.ClientDeath[%name] = ObserverHUDMissionData.ClientDeath[%name] $= "" ? 0 : ObserverHUDMissionData.ClientDeath[%name];
		%this.printHTMLLine(false, "Time", "c" @ %colourcode @",1,30%,", %time, "c" @ %colourcode @",2,20%,center", "Flag Caps", "c" @ %colourcode @",1,30%,", ObserverHUDMissionData.ClientFlagCap[%name], "c" @ %colourcode @",2,20%,center");
		%colourcode = %colourcode == 1 ? 0 : 1;
		%this.printHTMLLine(false, "Total Kills", "c" @ %colourcode @",1,30%,",ObserverHUDMissionData.ClientKill[%name], "c" @ %colourcode @",2,20%,center", "Flag Drops", "c" @ %colourcode @",1,30%,", ObserverHUDMissionData.ClientFlagDrop[%name], "c" @ %colourcode @",2,20%,center");
		%colourcode = %colourcode == 1 ? 0 : 1;
		%this.printHTMLLine(false, "Total Deaths", "c" @ %colourcode @",1,30%,", ObserverHUDMissionData.ClientDeath[%name], "c" @ %colourcode @",2,20%,center", "Flag Returns", "c" @ %colourcode @",1,30%,", ObserverHUDMissionData.ClientFlagReturn[%name], "c" @ %colourcode @",2,20%,center");
		%colourcode = %colourcode == 1 ? 0 : 1;
		%this.printHTMLLine(false, "Team Kills", "c" @ %colourcode @",1,30%,", ObserverHUDMissionData.ClientTeamKill[%name], "c" @ %colourcode @",2,20%,center", "Objective Grabs","c" @ %colourcode @",1,30%,", ObserverHUDMissionData.ClientGrab[%name], "c" @ %colourcode @",2,20%,center");
		%colourcode = 0;
		%this.printHTMLLine(false, "Weapon", "t,1,30%,center", "Kills","t,1,10%,center","Deaths","t,1,10%,center","Weapon", "t,1,30%,center", "Kills","t,1,10%,center","Deaths","t,1,10%,center");
		%maxlines = ObserverHUDWeaponArray.count/2;
		%maxweapons = ObserverHUDWeaponArray.count;
		if(mfloor(%maxlines) < %maxlines)
		{
			%maxlines = mfloor(%maxlines) + 1;
			%lastvalempty = true;
		}
		else
		{
			%lastvalempty = false;
		}
		for(%i=1; %i<%maxlines; %i++)
		{
			%weaponname2_id = %i*2;
			%weaponname1_id = %weaponname2_id-1;
			%weaponname2 = ObserverHUDWeaponArray.weapon[%weaponname2_id];
			%weaponname1 = ObserverHUDWeaponArray.weapon[%weaponname1_id];
			
			%tracker = "WeaponArrayKillsDeaths[" @ %name @ "]";
			
			%weaponKills_2 = %tracker.kills[%weaponname2];
			%weaponKills_1 = %tracker.kills[%weaponname1];
			
			%weaponDeaths_2 = %tracker.deaths[%weaponname2];
			%weaponDeaths_1 = %tracker.deaths[%weaponname1];
			
			if (%weaponDeaths_1 $= "") { %weaponDeaths_1 = 0; }
			if (%weaponDeaths_2 $= "") { %weaponDeaths_2 = 0; }
			if (%weaponKills_1 $= "") { %weaponKills_1 = 0; }
			if (%weaponKills_2 $= "") { %weaponKills_2 = 0; }
			
			%this.printHTMLLine(false, %weaponname1, "c" @ %colourcode @",1,30%,", %weaponKills_1,"c" @ %colourcode @",1,10%,center",%weaponDeaths_1,"c" @ %colourcode @",1,10%,center",%weaponname2, "c" @ %colourcode @",1,30%,",%weaponKills_2,"c" @ %colourcode @",1,10%,center",%weaponDeaths_2,"c" @ %colourcode @",1,10%,center");
			%colourcode = %colourcode == 1 ? 0 : 1;
		}
		if(%lastvalempty)
		{
			%weaponname1 = ObserverHUDWeaponArray.weapon[%maxweapons];
			%tracker = "WeaponArrayKillsDeaths[" @ %name @ "]";
			
			%weaponKills_1 = %tracker.kills[%weaponname1];
			%weaponDeaths_1 = %tracker.deaths[%weaponname1];

			if (%weaponDeaths_1 $= "") { %weaponDeaths_1 = 0; }
			if (%weaponKills_1 $= "") { %weaponKills_1 = 0; }
			
			%this.printHTMLLine(false, %weaponname1, "c" @ %colourcode @",1,30%,", %weaponKills_1,"c" @ %colourcode @",1,10%,center",%weaponDeaths_1,"c" @ %colourcode @",1,10%,center"," ", "c" @ %colourcode @",1,30%,"," ","c" @ %colourcode @",1,10%,center"," ","c" @ %colourcode @",1,10%,center");
		}
		else
		{
			%weaponname2_id = %i*2;
			%weaponname1_id = %weaponname2_id-1;
			%weaponname2 = ObserverHUDWeaponArray.weapon[%weaponname2_id];
			%weaponname1 = ObserverHUDWeaponArray.weapon[%weaponname1_id];
			%tracker = "WeaponArrayKillsDeaths[" @ %name @ "]";
			
			%weaponKills_2 = %tracker.kills[%weaponname2];
			%weaponKills_1 = %tracker.kills[%weaponname1];
			
			%weaponDeaths_2 = %tracker.deaths[%weaponname2];
			%weaponDeaths_1 = %tracker.deaths[%weaponname1];
			
			if (%weaponDeaths_1 $= "") { %weaponDeaths_1 = 0; }
			if (%weaponDeaths_2 $= "") { %weaponDeaths_2 = 0; }
			if (%weaponKills_1 $= "") { %weaponKills_1 = 0; }
			if (%weaponKills_2 $= "") { %weaponKills_2 = 0; }
			
			%this.printHTMLLine(false, %weaponname1, "c" @ %colourcode @",1,30%,", %weaponKills_1,"c" @ %colourcode @",1,10%,center",%weaponDeaths_1,"c" @ %colourcode @",1,10%,center",%weaponname2, "c" @ %colourcode @",1,30%,",%weaponKills_2,"c" @ %colourcode @",1,10%,center",%weaponDeaths_2,"c" @ %colourcode @",1,10%,center");
		}
		%this.filehtmleditor.writeline("<!-- End Player Info Content -->");
		%this.filehtmleditor.writeline("          </table>");
		%this.filehtmleditor.writeline("        </td>");
		%this.filehtmleditor.writeline("      </tr>");
		%this.filehtmleditor.writeline("    </table>");

		%z++;
		%p = PlayerList.findByIndex(%z);
	}

	%this.filehtmleditor.writeline("    <p>&nbsp;</p>");
	%this.filehtmleditor.writeline("<!-- End Player Stats Block -->");
}


