//Init Default schemes
$ObserverHUDSettings::ColourSchemeMax = 0;
$ObserverHUDSettings::IdtoColourScheme[1] = "Autumn";
$ObserverHUDSettings::ColourSchemetoID[Autumn] = 1;
$ObserverHUDSettings::ColourSchemeFileName[1] = "obshud_autumn.css";
$ObserverHUDSettings::ColourSchemeMax++;
$ObserverHUDSettings::IdtoColourScheme[2] = "Black";
$ObserverHUDSettings::ColourSchemetoID[Black] = 2;
$ObserverHUDSettings::ColourSchemeFileName[2] = "obshud_black.css";
$ObserverHUDSettings::ColourSchemeMax++;
$ObserverHUDSettings::IdtoColourScheme[3] = "Blue";
$ObserverHUDSettings::ColourSchemetoID[Blue] = 3;
$ObserverHUDSettings::ColourSchemeFileName[3] = "obshud_blue.css";
$ObserverHUDSettings::ColourSchemeMax++;
$ObserverHUDSettings::IdtoColourScheme[4] = "Cyan";
$ObserverHUDSettings::ColourSchemetoID[Cyan] = 4;
$ObserverHUDSettings::ColourSchemeFileName[4] = "obshud_cyan.css";
$ObserverHUDSettings::ColourSchemeMax++;
$ObserverHUDSettings::IdtoColourScheme[5] = "Green";
$ObserverHUDSettings::ColourSchemetoID[Green] = 5;
$ObserverHUDSettings::ColourSchemeFileName[5] = "obshud_green.css";
$ObserverHUDSettings::ColourSchemeMax++;
$ObserverHUDSettings::IdtoColourScheme[6] = "Ice";
$ObserverHUDSettings::ColourSchemetoID[Ice] = 6;
$ObserverHUDSettings::ColourSchemeFileName[6] = "obshud_ice.css";
$ObserverHUDSettings::ColourSchemeMax++;
$ObserverHUDSettings::IdtoColourScheme[7] = "Magenta";
$ObserverHUDSettings::ColourSchemetoID[Magenta] = 7;
$ObserverHUDSettings::ColourSchemeFileName[7] = "obshud_magenta.css";
$ObserverHUDSettings::ColourSchemeMax++;
$ObserverHUDSettings::IdtoColourScheme[8] = "Orange";
$ObserverHUDSettings::ColourSchemetoID[Orange] = 8;
$ObserverHUDSettings::ColourSchemeFileName[8] = "obshud_orange.css";
$ObserverHUDSettings::ColourSchemeMax++;
$ObserverHUDSettings::IdtoColourScheme[9] = "Red";
$ObserverHUDSettings::ColourSchemetoID[Red] = 9;
$ObserverHUDSettings::ColourSchemeFileName[9] = "obshud_red.css";
$ObserverHUDSettings::ColourSchemeMax++;
$ObserverHUDSettings::IdtoColourScheme[10] = "White";
$ObserverHUDSettings::ColourSchemetoID[White] = 10;
$ObserverHUDSettings::ColourSchemeFileName[10] = "obshud_white.css";
$ObserverHUDSettings::ColourSchemeMax++;
$ObserverHUDSettings::IdtoColourScheme[11] = "Yellow";
$ObserverHUDSettings::ColourSchemetoID[Yellow] = 11;
$ObserverHUDSettings::ColourSchemeFileName[11] = "obshud_yellow.css";
$ObserverHUDSettings::ColourSchemeMax++;
$ObserverHUDSettings::IdtoColourScheme[12] = "Custom";
$ObserverHUDSettings::ColourSchemetoID[Custom] = 12;
$ObserverHUDSettings::ColourSchemeFileName[12] = "custom.css";
$ObserverHUDSettings::ColourSchemeMax++;



//Use this function to add new 3rd party colour schemes
function AddCSSScheme(%name, %filename)
{
	$ObserverHUDSettings::ColourSchemeMax++;
	$ObserverHUDSettings::IdtoColourScheme[$ObserverHUDSettings::ColourSchemeMax] = %name;
	$ObserverHUDSettings::ColourSchemetoID[%name] = $ObserverHUDSettings::ColourSchemeMax;
	$ObserverHUDSettings::ColourSchemeFileName[$ObserverHUDSettings::ColourSchemeMax] = %filename;
}

//This function checks for existing css file and.......if none exists......creates one
function ObserverHUD::OutputCssFile(%this)
{
	if(!isFile("ObserverHUD/obshud.css"))
	{
		%this.fileCSSreader = new FileObject();
		%this.fileCSSwriter = new FileObject();
		%scheme = $ObserverHUDSettings::ColourScheme;
		if(%scheme $= "Custom")
			return;
		%id = $ObserverHUDSettings::ColourSchemetoID[%scheme];
		%filename = $ObserverHUDSettings::ColourSchemeFileName[%id];
		%outputstring = %this.fileCSSreader.getContents(%filename);
		%this.fileCSSwriter.openForWrite(%filename);
		%this.fileCSSwriter.writeline(%outputstring);
		%this.fileCSSwriter.close();
		%this.fileCSSreader.delete();
		%this.fileCSSwriter.delete();
		echo("ObserverHUD:  CSS Colour Scheme File Output Complete");
	}
}

function ObserverHUD::ForceOutputCssFile(%this)
{
	%scheme = $ObserverHUDSettings::ColourScheme;
	if(%scheme $= "Custom")
		return;
	%this.fileCSSreader = new FileObject();
	%this.fileCSSwriter = new FileObject();
	%id = $ObserverHUDSettings::ColourSchemetoID[%scheme];
	%filename = "wizard/"@$ObserverHUDSettings::ColourSchemeFileName[%id];
	%outputstring = %this.fileCSSreader.getContents(%filename);
	%this.fileCSSwriter.openForWrite("ObserverHUD/obshud.css");
	%this.fileCSSwriter.writeline(%outputstring);
	%this.fileCSSwriter.close();
	%this.fileCSSreader.delete();
	%this.fileCSSwriter.delete();
	echo("ObserverHUD:  CSS Colour Scheme File Output Complete");
}

function ObserverHUD::IncludeCssFile(%this)
{
	if(!isobject(%this.fileCSSeditor))
	{
		 %this.fileCSSeditor = new FileObject();
	}
	%scheme = $ObserverHUDSettings::ColourScheme;
	%id = $ObserverHUDSettings::ColourSchemetoID[%scheme];
	%filename = "wizard/"@$ObserverHUDSettings::ColourSchemeFileName[%id];
	%outputstring = %this.fileCSSeditor.getContents(%filename);
	%this.filehtmleditor.writeline(%outputstring);
	%this.fileCSSeditor.delete();
}
